#ifndef VERSION_H_INCLUDED
#define VERSION_H_INCLUDED /* allow multiple inclusions */

/* 
 * Prospect: a developer's system profiler.
 *
 * COPYRIGHT (C) 2001-2004 Hewlett-Packard Company
 *
 * Author: Alex Tsariounov, HP
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* $Id: version.h,v 1.38 2004/01/14 02:08:12 type2 Exp $ */

/*
 * The version number of prospect.  Note that this corresponds 
 * to the cvs tag name too.  So to recreate, cvs co -r version
 * according to the convention:
 *
 *    i.e.  cREV="0.9.5"           -   cvs_tag="RELEASE_0_9_5"
 *          cREV="0.9.5_pre3"      -   cvs_tag="preview_0_9_5_pre3"
 *
 *          cREV="0.9.6cvs"        - No tag: this is just in cvs, i.e.
 *                                   this is not released yet.
 *
 * Unreleased code generally carries a version number with a 
 * "cvs" or something (as above) - do not allow distribution of
 * untagged code!  You risk not being able to reproduce.
 *
 * Note that if this is a preview or pre-release release, then
 * leave a space between the number and the preview marker 
 * in cREV because the tar build script looks for that.
 *
 * Also note that these are strings and thus must be in quotes.
 */


#define cREV "0.9.8b"
#define cDISDATE "January 2004"

#ifdef __ia64__
#define cOSREV "Linux/ia64"
#else
#define cOSREV "Linux/ia32"
#endif


#endif  /* !VERSION_H_INCLUDED */

